# -*- coding: utf-8 -*-
"""
Created on Tue Jul 12 10:59:11 2022

@author: User
"""

import matplotlib.pyplot as plt
import numpy as np
from scipy.signal import hilbert





# =============================================================================
# Pas de dispersion : vphi = cte
# =============================================================================

# vphi = 1.


# # # =============================================================================
# # # Définition du paquet d'onde
# # # Somme de deux fonctions sinusoïdales de fréquences très proches  
# # # =============================================================================

# def Paquet_onde(x,t):
    
#     f0 = 4
#     df = 0.05*f0
    
#     S = np.zeros(Nx)
    
#     f1 = f0 - df
    
#     S = S + 25 * np.cos(2*np.pi*f1*(t-x/vphi))
    
#     f2 = f0 + df
    
#     S = S + 25 * np.cos(2*np.pi*f2*(t-x/vphi))
    
    
#     return S

# # =============================================================================
# # Tracé du paquet d'onde à deux instants différents
# # =============================================================================


# x_min = 0
# x_max = 10
# Nx = 1000

# X = np.linspace(x_min,x_max,Nx)

# t = 1.5
# P1 = Paquet_onde(X,t)
# plt.plot(X,P1,color = 'b',label = ' t = 1.5')

# t = 5.5
# P2 = Paquet_onde(X,t)
# plt.plot(X,P2,color = 'r',label = ' t = 5.5')

# plt.title("Paquet d'onde pour t = 1.5 et t = 5.5 - Pas de dispersion")
# plt.legend()

# plt.show()



# # # =============================================================================
# # # Avec dispersion : Vitesse de phase de la forme c/sqrt(1-(omega_c**2/omega)**2)
# # # Somme de deux fonctions sinusoïdales de fréquences très proches
# # # =============================================================================

# def Paquet_onde(x,t):
    
#     fc = 3
#     c = 0.6

#     f0 = 4
#     df = 0.05 * f0
    
#     S = np.zeros(Nx)
    
#     f1 = f0 - df
#     vphi = c/np.sqrt(1-(fc/f1)**2)
#     S = S + 25 * np.cos(2*np.pi*f1*(t-x/vphi))
#     f2 = f0 + df
#     vphi = c/np.sqrt(1-(fc/f2)**2)
#     S = S + 25 * np.cos(2*np.pi*f2*(t-x/vphi))      
    
#     return S

# x_min = 0
# x_max = 10
# Nx = 1000

# X = np.linspace(x_min,x_max,Nx)

# t = 1.5
# P1 = Paquet_onde(X,t)
# plt.plot(X,P1,color = 'b',label = ' t = 1.5')

# t = 5.5
# P2 = Paquet_onde(X,t)
# plt.plot(X,P2,color = 'r',label = ' t = 5.5')

# plt.title("Paquet d'onde pour t = 1.5 et t = 5.5 - Pas de dispersion")
# plt.legend()

# plt.title("Paquet d'onde pour t = 1.5 et t = 10 - Avec dispersion")

# plt.show()


# # # =============================================================================
# # # Animation du paquet d'onde
# # # =============================================================================
    
import matplotlib.animation as animation

Nx = 1000

def Paquet_onde(x,t):
    
    fc = 3
    c = 0.6

    f0 = 4
    df = 0.05 * f0
    
    S = np.zeros(Nx)
    
    f1 = f0 - df
    vphi = c/np.sqrt(1-(fc/f1)**2)
    S = S + 25 * np.cos(2*np.pi*f1*(t-x/vphi))
    f2 = f0 + df
    vphi = c/np.sqrt(1-(fc/f2)**2)
    S = S + 25 * np.cos(2*np.pi*f2*(t-x/vphi))      
    
    return S

fig = plt.figure(num=0,figsize=(12,12))
a0=plt.subplot2grid((1,1),(0,0))
a0.set_xlim(-1,10)
a0.set_ylim(-100,100)
a0.grid(True)
a0.set_title('Propagation avec dispersion')



def Enveloppe_p(P):
    analytic_signal = hilbert(P)
    return  np.abs(analytic_signal)

    

def Sommet(t):
    
    Pmax_x0 = 0
    fc = 3
    c = 0.6
    f0 = 4
    
    vg =  c*np.sqrt(1-(fc/f0)**2)
    
    return Pmax_x0 + vg*t


x_min = 0
x_max = 10
Nx = 1000
X = np.linspace(x_min,x_max,Nx)

t_min = 0
t_max = 20
Nt = 500
dt = (t_max-t_min)/Nt


line, = a0.plot([],[],linewidth=3,color='b') 
line_env_p, = a0.plot([],[],'--',linewidth=1,color='r')
line_env_m, = a0.plot([],[],'--',linewidth=1,color='r')



line_sommet, = a0.plot([],[],linewidth=2,color='g') 

def init():
     
    P = Paquet_onde(X,t_min)
    
    E_P = Enveloppe_p(P)
    E_M = (-1)*E_P
    
    
    S = Sommet(t_min)
    line.set_data(X,P)
    line_env_p.set_data(X,E_P)
    line_env_m.set_data(X,E_M)
    
    line_sommet, = a0.plot([S,S],[-100,100],linewidth=3,color='g') 
    
    return line,line_sommet,line_env_p,line_env_m

   


def animate(j): 
    
    t = t_min + (j+1)*dt
    P = Paquet_onde(X,t)
    
    E_P = Enveloppe_p(P)
    E_M = (-1)*E_P

    
    S = Sommet(t)
    line.set_data(X,P)
    line_env_p.set_data(X,E_P)
    line_env_m.set_data(X,E_M)
    
    line_sommet, = a0.plot([S,S],[-100,100],linewidth=3,color='g') 
    return line,line_sommet,line_env_p,line_env_m 
    


 
ani = animation.FuncAnimation(fig, animate, init_func=init, frames=Nt, blit=True, interval=20, repeat=False)
plt.show()
